
function $(id)
{
    return document.getElementById(id);
}

var SkinEngine = 
{
    _skinParams : null,
    //     
    _playListIsVisible : false,
    //
    _isDocked: true,
    //      
    OnDock : null,
    //      
    OnUnDock : null,
    //    
    OnSettingClose: null,
    //  xml j      Play List.xml
    GetPlayList: function()
    {
        var playListXmlObj = new ActiveXObject("Microsoft.XMLDOM");
        playListXmlObj.load(".\\Play List.xml");
        return playListXmlObj;
    },
    
    _GadgetEventOnDock: function()
    {
        if (SkinEngine.OnDock)
            SkinEngine.OnDock();
        SkinEngine._isDocked = true;
        ApplySkinParams(SkinEngine._CurentSkinParams());
    },
    
    _GadgetEventOnUnDock: function()
    {
        if (SkinEngine.OnUnDock)
            SkinEngine.OnUnDock();
        SkinEngine._isDocked = false;
        ApplySkinParams(SkinEngine._CurentSkinParams());
    },
    
    _GadgetEventOnSettingClose: function()
    {
        if (OnSettingClose)
            OnSettingClose();
    },
    
    _CurentSkinParams: function()
    {
        if (SkinEngine._isDocked)
            return _skinParams.Docked;
        return _skinParams.UnDocked;
    },
    
    Run : function(SkinParams)
    {
        _skinParams = SkinParams;
        System.Gadget.settingsUI       = "settings.html";
        System.Gadget.onSettingsClosed = SkinEngine._GadgetEventOnSettingClose;
        System.Gadget.onDock           = SkinEngine._GadgetEventOnDock;
        System.Gadget.onUndock         = SkinEngine._GadgetEventOnUnDock;
        ApplySkinParams(_skinParams.Docked);
    },
    
    ShowOrHiddePlayList : function()
    {
        SkinEngine._playListIsVisible = !SkinEngine._playListIsVisible;
        ApplySkinParams(SkinEngine._CurentSkinParams());
    },
    IsDocked: function()
    {
        return SkinEngine._isDocked;
    }
}

function ApplyPositionToButton(button, position)
{
    button.style.left = position.left;
    button.style.top  = position.top;
}

function ApplyRectangleToButton(button, rectangle)
{
    button.style.left   = rectangle.left;
    button.style.top    = rectangle.top;
    button.style.width  = rectangle.width;
    button.style.height = rectangle.height;
}

function ApplySkinParams(params)
{
    currentSkinParams = params;
    var btnPlay     = $("Play");
    var btnRec      = $("Rec");
    var btnPrevious = $("Previous");
    var btnNext     = $("Next");
    var btnPlayList = $("PlayListButton");
    var textBox     = $("Text");
    var playListStyle    = $("PlayList").style;
    var bodyStyle        = document.body.style;
    
    ApplyPositionToButton(btnPlay, params.Buttons.Play);
    ApplyPositionToButton(btnRec, params.Buttons.Rec);
    ApplyPositionToButton(btnPrevious, params.Buttons.Previous);
    ApplyPositionToButton(btnNext, params.Buttons.Next);

    textBox.style.left = params.TextBox.left;
    textBox.style.top = params.TextBox.top;
    textBox.style.width = params.TextBox.width;
    textBox.style.height = params.TextBox.height;
    
    if (SkinEngine._playListIsVisible)
    {
        bodyStyle.width       = params.width;
        bodyStyle.height      = params.height + params.PlayList.height; 
        playListStyle.left    = params.PlayList.PlayListInformation.left;
        playListStyle.top   = params.PlayList.PlayListInformation.top;
        playListStyle.width   = params.PlayList.PlayListInformation.width;
        playListStyle.height  = params.PlayList.PlayListInformation.height;
        playListStyle.display = "block";
        bodyStyle.backgroundImage = "url(\""+params.PlayList.backgroundImageURL+"\")";
        ApplyRectangleToButton(btnPlayList, params.PlayList.ShowButton);
    }
    else
    {
        bodyStyle.width  = params.width;
        bodyStyle.height = params.height;
        playListStyle.display = "none";
        bodyStyle.backgroundImage = backgroundImage = "url(\""+params.backgroundImageURL+"\")";
        ApplyRectangleToButton(btnPlayList, params.PlayList.HiddeButton);
    }
}
